Subject: [storm] iSCSI version descriptors

From: <[email-masked]>
Date: Fri, 22 Oct 2010 01:14:39 -0400

One more time on this issue.  This is for discussion - it's not an announcement of a decision.  This is the only real issue that needs to be resolved to complete the new (SAM) features draft for iSCSI.

Reminder: we need to define a set of small positive integer values to describe the iSCSI version starting with 0 = "no version claimed".  After some private discussions, it appears that we need two additional version values beyond 0.

The first observation is that the baseline should be at least RFC 3720 (original iSCSI) + RFC 5048 (Corrections and Clarifications).  That would be version value 1.

The next observation is that taking features out of the consolidated iSCSI draft may allow a visible behavior change.  RFC 3720 has this to say about text keys for negotiation:

   All keys in this document, except for the X extension formats, MUST
   be supported by iSCSI initiators and targets when used as specified
   here.  If used as specified, these keys MUST NOT be answered with
   NotUnderstood.

When we take out a feature in the new iSCSI consolidated draft, the easiest thing to do is allow a NotUnderstood response to the keys that negotiate that feature.  This should not pose a problem for unimplemented features, but it would be a behavior change.  The completely backwards-compatible alternative is have the consolidated iSCSI draft list the keys used for removed features and prohibit  a NotUnderstood response to those keys (Reject would be an acceptable alternative response).

If we're careful about this, the same version value can apply to 3720/5048 and the consolidated iSCSI draft.  I'd suggest that we be careful, and the details of how can be worked out as we finalize the consolidated draft - I think we should have at least one more round of looking at features to remove.

After that, we'll need a version value for the new (SAM) features draft additions.  The result would be 3 version values:
	0 = no version claimed
	1 = 3720/5048 or new consolidated draft
	2 = (3720/5048 or new consolidated draft) + SAM 4/5 features from the SAM draft.

Comments?

The SAM 4/5 features draft will expire while draft submission is closed for the Beijing meeting - if we can resolve this issue, the next version of that draft could be submitted shortly after draft submission opens again, and would probably go to WG Last Call shortly thereafter.

Thanks,
--David
----------------------------------------------------
David L. Black, Distinguished Engineer
EMC Corporation, 176 South St., Hopkinton, MA  01748
+1 (508) 293-7953             FAX: +1 (508) 293-7786
[email-masked]        Mobile: +1 (978) 394-7754
----------------------------------------------------

---

From: Paul Koning <[email-masked]>
Date: Fri, 22 Oct 2010 11:14:17 -0400

> When we take out a feature in the new iSCSI consolidated draft, the easiest thing to do is allow a NotUnderstood response to the keys that negotiate that feature.  This should not pose a problem fo…

That sounds right.  Does it cause problems for that to be the answer?  

> If we're careful about this, the same version value can apply to 3720/5048 and the consolidated iSCSI draft.  I'd suggest that we be careful, and the details of how can be worked out as we finalize…

Yes, using the same version should be a goal.

> 	2 = (3720/5048 or new consolidated draft) + SAM 4/5 features from the SAM draft.

I assume these numbers will be handled by IANA, so they'll need an IANA Considerations section spelling out how.

For now, I believe we should say 3270/5048 and not mention "new consolidated draft".  It doesn't seem appropriate to reference a draft.  If we end up being able to reuse the code for the consolidated spec, as intended, then at the time that spec comes out, the description of the code points would be updated to say that it applies to that RFC as well.

For the SAM draft, can we reference a specific draft?  I think it's quite absurd that drafts even have standard status in the first place, but given that they do, we need to be precise about which document we're talking about.  If we say "draft 2010/10/34" now, and then a followup draft comes out for which the same code point is appropriate, we'd update the description of the code point to list that one as well.  But we can't leave it unstated.

	paul

---

From: "Knight, Frederick" <[email-masked]>
Date: Fri, 22 Oct 2010 15:02:20 -0400

The consolidated draft incorporates:

Updates: RFC 3720, 3721, 3980, 4850, 5048

Due to RFC4850, the consolidated draft is different than just 3720+5048 (4850 created the "X#NodeArchitecture" key).

How should we handle this?  Do we need:
	0 = no version claimed
	1 = 3720/5048
	2 = 3720/4850/5048 or new consolidated draft
	3 = (3720/4850/5048 or new consolidated draft) + SAM 4/5 features from the SAM draft.

	Fred Knight

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] 
Sent: Friday, October 22, 2010 1:15 AM
To: [email-masked]
Subject: [storm] iSCSI version descriptors

Comments?

Thanks,
--David

_______________________________________________
storm mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/storm

---

From: <[email-masked]>
Date: Sun, 24 Oct 2010 15:31:53 -0400

> "X#NodeArchitecture" key).

That's an X extension format key, for which a NotUnderstood response is possible (RFC 4850 explicitly says so), and the key is only announced, not negotiated.

> How should we handle this?  Do we need:

I don't think 4850's presence/absence makes a sufficient difference, so I'd combine 1 and 2 above, plus rephrase the description of 3 (which would then become the new 2).

Thanks,
--David

> From: Knight, Frederick [mailto:[email-masked]]
> Sent: Friday, October 22, 2010 3:02 PM
> To: Black, David; [email-masked]
> Subject: RE: [storm] iSCSI version descriptors
> 
> One more time on this issue.  This is for discussion - it's not an announcement of a decision.  This
> is the only real issue that needs to be resolved to complete the new (SAM) features draft for iSCSI.
> 
> Reminder: we need to define a set of small positive integer values to describe the iSCSI version
> starting with 0 = "no version claimed".  After some private discussions, it appears that we need two
> additional version values beyond 0.
> 
> The first observation is that the baseline should be at least RFC 3720 (original iSCSI) + RFC 5048
> (Corrections and Clarifications).  That would be version value 1.
> 
> The next observation is that taking features out of the consolidated iSCSI draft may allow a visible
> behavior change.  RFC 3720 has this to say about text keys for negotiation:
> 
> When we take out a feature in the new iSCSI consolidated draft, the easiest thing to do is allow a
> NotUnderstood response to the keys that negotiate that feature.  This should not pose a problem for
> unimplemented features, but it would be a behavior change.  The completely backwards-compatible
> alternative is have the consolidated iSCSI draft list the keys used for removed features and
> prohibit  a NotUnderstood response to those keys (Reject would be an acceptable alternative
> response).
> 
> If we're careful about this, the same version value can apply to 3720/5048 and the consolidated
> iSCSI draft.  I'd suggest that we be careful, and the details of how can be worked out as we
> finalize the consolidated draft - I think we should have at least one more round of looking at
> features to remove.
> 
> The SAM 4/5 features draft will expire while draft submission is closed for the Beijing meeting - if
> we can resolve this issue, the next version of that draft could be submitted shortly after draft
> submission opens again, and would probably go to WG Last Call shortly thereafter.
> 
> Thanks,
> --David

---

From: <[email-masked]>
Date: Mon, 25 Oct 2010 09:55:41 -0400

> For now, I believe we should say 3270/5048 and not mention "new consolidated draft".  It doesn't
> seem appropriate to reference a draft.  If we end up being able to reuse the code for the
> consolidated spec, as intended, then at the time that spec comes out, the description of the code
> points would be updated to say that it applies to that RFC as well.

Yes, the specifications of the version code values need to be in terms of RFC numbers, not references to Internet-Drafts.

Thanks,
--David

> From: Paul Koning [mailto:[email-masked]]
> Sent: Friday, October 22, 2010 11:14 AM
> To: Black, David
> Cc: [email-masked]
> Subject: Re: [storm] iSCSI version descriptors
> 
> 
> > One more time on this issue.  This is for discussion - it's not an announcement of a decision.
> This is the only real issue that needs to be resolved to complete the new (SAM) features draft for
> iSCSI.
> >
> > The next observation is that taking features out of the consolidated iSCSI draft may allow a
> visible behavior change.  RFC 3720 has this to say about text keys for negotiation:
> >
> For now, I believe we should say 3270/5048 and not mention "new consolidated draft".  It doesn't
> seem appropriate to reference a draft.  If we end up being able to reuse the code for the
> consolidated spec, as intended, then at the time that spec comes out, the description of the code
> points would be updated to say that it applies to that RFC as well.
> 
> For the SAM draft, can we reference a specific draft?  I think it's quite absurd that drafts even
> have standard status in the first place, but given that they do, we need to be precise about which
> document we're talking about.  If we say "draft 2010/10/34" now, and then a followup draft comes out
> for which the same code point is appropriate, we'd update the description of the code point to list
> that one as well.  But we can't leave it unstated.
> 
> 	paul
>